/*
 * Copyright (C) 2015 Laboratoire ThéMA - UMR 6049 - CNRS / Université de Franche-Comté
 * http://thema.univ-fcomte.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


package org.thema.mupcity;

import org.locationtech.jts.geom.Envelope;
import java.awt.geom.AffineTransform;
import java.awt.geom.Rectangle2D;
import org.thema.mupcity.rule.RuleParamDialog;
import org.geotools.referencing.operation.matrix.XAffineTransform;
import org.thema.common.JTS;
import org.thema.drawshape.GridModShape;
import org.thema.msca.SquareGridFactory;
import org.thema.drawshape.RectModShape;
import org.thema.msca.MSGrid;
import org.thema.msca.MSGridBuilder;

/**
 * Dialog form for defining the decomposition parameters for the multiscale grid and the rules parameters.
 * Launch the creation of the multiscale grid and the rules calculation.
 * 
 * @author  Gilles Vuidel
 */
public class DecompDlg extends javax.swing.JDialog {
    
    /** the minimum size of cells */
    private double min;
    /** the maximum size of cell */
    private double max;
    /** the factor between scale */
    private int exp;
    /** the minimal density for a cell to be built */
    private double seuilDensBuild;
    
    private RectModShape bounds;
    private MainFrame main;
    
    /** 
     * Creates new form DecompDlg 
     * @param parent the main frame
     * @param bounds the current rectangular bounds
     */
    public DecompDlg(MainFrame parent, RectModShape bounds) {
        super(parent, false);
        initComponents();
        setLocationRelativeTo(parent);
        max = Math.floor(Math.min(XAffineTransform.getScaleX0(bounds.getTransform())/2,
                XAffineTransform.getScaleY0(bounds.getTransform())/2));
        maxSizeTextField.setText(""+max);
        this.bounds = bounds;
        main = parent;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        expTextField = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        maxSizeTextField = new javax.swing.JTextField();
        minSizeTextField = new javax.swing.JTextField();
        decompButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        previewButton = new javax.swing.JButton();
        jLabel4 = new javax.swing.JLabel();
        seuilDensBatiTextField = new javax.swing.JTextField();
        ruleButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/thema/mupcity/Bundle"); // NOI18N
        setTitle(bundle.getString("DecompDlg.title")); // NOI18N

        expTextField.setText(bundle.getString("DecompDlg.expTextField.text")); // NOI18N

        jLabel1.setText(bundle.getString("DecompDlg.jLabel1.text")); // NOI18N

        jLabel2.setText(bundle.getString("DecompDlg.jLabel2.text")); // NOI18N

        jLabel3.setText(bundle.getString("DecompDlg.jLabel3.text")); // NOI18N

        minSizeTextField.setText(bundle.getString("DecompDlg.minSizeTextField.text")); // NOI18N

        decompButton.setText(bundle.getString("DecompDlg.decompButton.text")); // NOI18N
        decompButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                decompButtonActionPerformed(evt);
            }
        });

        cancelButton.setText(bundle.getString("DecompDlg.cancelButton.text")); // NOI18N
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        previewButton.setText(bundle.getString("DecompDlg.previewButton.text")); // NOI18N
        previewButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                previewButtonActionPerformed(evt);
            }
        });

        jLabel4.setText(bundle.getString("DecompDlg.jLabel4.text")); // NOI18N

        seuilDensBatiTextField.setText(bundle.getString("DecompDlg.seuilDensBatiTextField.text")); // NOI18N

        ruleButton.setText(bundle.getString("DecompDlg.ruleButton.text")); // NOI18N
        ruleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ruleButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel3)
                            .add(jLabel1)
                            .add(jLabel2))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(minSizeTextField)
                            .add(expTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 31, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(maxSizeTextField)
                            .add(previewButton))
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(18, 18, 18)
                                .add(jLabel4)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(seuilDensBatiTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 60, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(ruleButton))))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(decompButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(cancelButton)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(expTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel4)
                    .add(seuilDensBatiTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel3)
                    .add(minSizeTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel2)
                            .add(maxSizeTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(18, 18, 18)
                        .add(previewButton))
                    .add(layout.createSequentialGroup()
                        .add(19, 19, 19)
                        .add(ruleButton)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(decompButton)
                    .add(cancelButton))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        setVisible(false);
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void decompButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_decompButtonActionPerformed
        previewButtonActionPerformed(null);
        seuilDensBuild = Double.parseDouble(seuilDensBatiTextField.getText());
        
        setVisible(false);
        dispose();

        main.decomp(exp, max, min, seuilDensBuild);
    }//GEN-LAST:event_decompButtonActionPerformed

    private void previewButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_previewButtonActionPerformed
        min = Double.parseDouble(minSizeTextField.getText());
        max = Double.parseDouble(maxSizeTextField.getText());
        exp = Integer.parseInt(expTextField.getText());
        AffineTransform trans = bounds.getTransform();
        double width = XAffineTransform.getScaleX0(trans);
        double height = XAffineTransform.getScaleY0(trans);
        double rot = XAffineTransform.getRotation(trans);
        MSGridBuilder<MSGrid> msGrid = new MSGridBuilder(JTS.geomFromRect(new Rectangle2D.Double(0, 0, width, height)), min, max, exp, 0, new SquareGridFactory());
        Envelope env = msGrid.getGrid(min).getEnvelope();

        AffineTransform newTrans = AffineTransform.getTranslateInstance(trans.getTranslateX(), trans.getTranslateY());
        newTrans.concatenate(AffineTransform.getScaleInstance(env.getWidth(), env.getHeight()));
        newTrans.concatenate(AffineTransform.getRotateInstance(rot));
        bounds.setTransform(newTrans);
        max = msGrid.getResolutions().first();
        maxSizeTextField.setText(""+max);
        if(bounds instanceof GridModShape) {
            ((GridModShape)bounds).setGridSize(max);
        }
    }//GEN-LAST:event_previewButtonActionPerformed

    private void ruleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ruleButtonActionPerformed
        new RuleParamDialog(main, main.getProject()).setVisible(true);
    }//GEN-LAST:event_ruleButtonActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JButton decompButton;
    private javax.swing.JTextField expTextField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JTextField maxSizeTextField;
    private javax.swing.JTextField minSizeTextField;
    private javax.swing.JButton previewButton;
    private javax.swing.JButton ruleButton;
    private javax.swing.JTextField seuilDensBatiTextField;
    // End of variables declaration//GEN-END:variables
    
}
